﻿using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Windows;
using Stimulsoft.Report;
using Stimulsoft.Report.Dictionary;
using System.IO;

namespace WpfApplication1
{
	public partial class MainWindow
	{
		public MainWindow()
		{
			InitializeComponent();
			Loaded += MainWindow_Loaded;
		}
		
		void MainWindow_Loaded(object sender, RoutedEventArgs e)
		{
			var report = new StiReport();
			report.LoadFromString(File.ReadAllText(@"..\..\Report.mrt"));
			var databaseFile = new FileInfo(@"..\..\MyData.mdf").FullName;
			SetConnectionString(report, @"Data Source=(LocalDB)\v11.0;AttachDbFilename=""" + databaseFile + @""";Integrated Security=True;Connect Timeout=30");

			report.RenderWithWpf(false);
			Viewer.Report = report;
		}

		private static void SetConnectionString(StiReport stiReport, string connectionString)
		{
			var names = new List<string>();
			foreach (var obj in stiReport.Dictionary.Databases)
			{
				var sqlDatabase = obj as StiSqlDatabase;
				if (sqlDatabase == null) continue;
				names.Add(sqlDatabase.Name);
			}

			stiReport.Dictionary.Databases.Clear();
			foreach (var name in names)
			{
				var db = new StiSqlDatabase(name, connectionString);
				stiReport.Dictionary.Databases.Add(db);
			}
		}
	}
}
